#include "datamanager.h"

void menu_print()
{
	system("cls");
	printf("\n*****************   TANTRGYFELOSZTS   *****************\n");
	printf("  MEN\n");
	printf("\t1  input fjlbl\n");
	printf("\t2  input konzolrl\n");
	printf("\t3  egyedi bejegyzs hozzadsa\n");
	printf("\t4  egyedi bejegyzs trlse\n");
	printf("\t5  napl trlse\n");
	printf("\t6  listzs\n");
	printf("\t\ta  bejegyzsek listja\n");
	printf("\t\tb  tanrok listja\n");
	printf("\t\tc  tantrgyak listja\n");
	printf("\t\td  csoportok listja\n");
	printf("\t7  statisztika (rettsgi feladat 2-7)\n");
	printf("\t\ta  bejegyzsek szma\n");
	printf("\t\tb  sszes raszm\n");
	printf("\t\tc  adott tanr raszma\n");
	printf("\t\td  osztlyfnkk listja\n");
	printf("\t\te  csoportbonts lekrdezs\n");
	printf("\t\tf  tanrok szma\n");
	printf("\t\tg  teljes statisztika\n");
	printf("\t8  kilps\n");
}

void input_stringfield(const char * label, char* field, unsigned capacity)
{
	printf("%s: ", label);
	fgets(field, capacity + 1, stdin);
	if(field[strlen(field) - 1] == '\n')
		field[strlen(field) - 1] = '\0';
	else if(getc(stdin) != '\n')
		while(getc(stdin) != '\n');
}

void input_intfield(const char* label, int* field, int minvalue, int maxvalue)
{
	bool hiba;
	*field = STORNO;
	do {
		hiba = false;
		printf("%s: ", label);
		int e = scanf("%d%*[^\n]", field);
		scanf("%*c");
		if (e != 1) {
			hiba = true;
			printf("Egsz szmot rjon be!\n");
			while(getc(stdin) != '\n');
		} else if((*field < minvalue || *field > maxvalue) && *field != STORNO) {
			hiba = true;
			printf("Nem relis az adat. %d s %d kztti rtket adjon meg!\n", minvalue, maxvalue);
		} else /*if(*field == STORNO || (*field >= minvalue && *field <= maxvalue)*/
            hiba = false;
	} while(hiba);
}


EduList file_input(EduList el)
{
	FILE* ifp;
	char* fnev = "beosztas.txt";
	ifp = fopen(fnev, "r");
	if(ifp == NULL) {
		fclose(ifp);
		printf("Nem sikerlt a fjlt megnyitni. A naplo llapota nem vltozott.\n");
		return el;
	}
	if(el.length != 0){
		edulist_free(&el);
		printf("A napl nem volt res. A korbbi adatok trldtek\n");
	}
	EduRec e = create_edurec(ifp);
	while(!feof(ifp) && e.ora != STORNO) {
		el = edulist_append(el, e);
		e = create_edurec(ifp);
	}
	printf("\tBeolvass ksz.\n");
	fclose(ifp);
	return el;
}


EduList stdin_input(EduList el)
{
	if(el.length!= 0) {
		int valasz;
		printf("A napl nem res. Hozzfzs esetn dupliktum jhet ltre.\n");
		printf("\ta: append - jelenlegi bejegyzsek megtartsa\n");
		printf("\tc: clear  - jelenlegi bejegyzsek trlse\n");

		do {
			printf("vlasszon (a|c): ");
			valasz = getchar();
			while(getchar()!= '\n');
		} while(valasz != 'a' && valasz != 'c');
		if(valasz == 'c')
			edulist_free(&el);
	}
	char* inputlabels[] = {
                "\tTanr neve [maxhossz 30]",
                "\tTantrgy [maxhossz 20]",
                "\tCsoport [maxhossz 7]",
                "\t-1 | raszm [0;40]"
                };
	EduRec e = input_edurec(inputlabels);
	while(e.ora != STORNO) {
		el = edulist_append(el, e);
		printf("\n");
		e = input_edurec(inputlabels);
	}
	printf("\tBeolvass vge\n");
	return el;
}


StringSet teacherlist(EduList e)
{
	StringSet Teacher = stringset_inic(TMAX);
	if(e.length != 0)
		for(EduNode* act=e.first; act != e.last->next; act = act->next)
			stringset_insert(&Teacher, act->adat.teacher);
	return Teacher;
}


StringSet subjectlist(EduList e)
{
	StringSet Subject = stringset_inic(SMAX);
	if(e.length != 0)
		for(EduNode* act=e.first; act != e.last->next; act = act->next)
			stringset_insert(&Subject, act->adat.subject);
	return Subject;
}


StringSet grouplist(EduList e)
{
	StringSet Group = stringset_inic(GMAX);
	if(e.length != 0)
		for(EduNode* act=e.first; act != e.last->next; act = act->next)
			stringset_insert(&Group, act->adat.group);
	return Group;

}


void datafield_print(EduList el, StringSet (*fieldlist)(EduList e))
{
	StringSet lista = fieldlist(el);
	stringset_fprint(stdout, lista);
	stringset_free(&lista);
}

void todoitem()
{
	system("cls");
	printf("\n\n\tA szolgltats fejelszts alatt, j vlasztshoz ssn Entert");
	while(getc(stdin) != '\n');
}
