#include <stdio.h>
#include <stdlib.h>
#include "edulist.h"
#include "edurec.h"
#include "datamanager.h"


//listaelem fggvnyek
EduNode* create_edunode(EduRec er)
{
    EduNode* uj = (EduNode*)malloc(sizeof(EduNode));
    uj->adat = er;
    uj->next = NULL;
    return uj;
}

void delete_edunode(EduNode* en)
{
    free(en);
}

//lista fggvnyek
EduList edulist_inic()
{
    EduList uj;
    uj.first = NULL;
    uj.last = NULL;
    uj.length = 0;
    return uj;
}

EduList edulist_append(EduList el, EduRec er)
{
    if(er.ora == STORNO)
        return el;
    EduNode* uj = create_edunode(er);
    if(el.first == NULL){
        el.first = uj;
        el.last = uj;
        el.length = 1;
    }
    else{
        el.last->next = uj;
        el.last = uj;
        el.length++;
    }
    return el;
}

EduNode* edulist_find(EduList el, EduRec er)
{
    if(el.length == 0)
        return NULL;
    EduNode* act;
    for(act = el.first; act != el.last->next; act = act->next)
    {
        if(strcmp(act->adat.teacher, er.teacher) == 0 &&
           strcmp(act->adat.subject, er.subject) ==0 &&
           strcmp(act->adat.group, er.group) == 0 &&
           (act->adat.ora == er.ora))
                break;
    }
    return act;
}

void edulist_delete(EduList* el, EduRec er)
{
    EduNode* ezt = edulist_find(*el, er);
    if(ezt != NULL)
    {
        if(el->first == ezt){
            el->first = ezt->next;
        }
        else{
        EduNode* act;
        for(act = el->first; act->next != ezt; act = act->next)
            ;
        act->next = ezt->next;
        }
        el->length--;
        delete_edunode(ezt);
        printf("\n\tA megadott bejegyzs trlve.\n");
    }
    else
        printf("\nNincs megfelel bejegyzs.\n");
}

void edulist_free(EduList* el)
{
    EduNode* act;
    for(act = el->first; act != el->last; act = el->first)
    {
        el->first = act->next;
        delete_edunode(act);
        el->length--;
    }
    act = NULL;
    el->first = NULL;
    delete_edunode(el->last);
    el->length--;
    *el = edulist_inic();
}

void edulist_print(EduList el)
{
    if(el.length == 0)
    {
        printf("res tantrgyfeloszts.\n");
        return;
    }
    int sor = 0;
    EduNode* act;
    for(act = el.first; act != el.last->next; act = act->next) {
        lineprint_edurec(act->adat);
        sor++;
        if(sor == 20){
            printf("Folytatshoz ssn Entert...\n");
            while(getc(stdin) != '\n');
            sor = 0;
        }
    }
}
