#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "edurec.h"
#include "edulist.h"
#include "statistics.h"
#include "datamanager.h"

#define WIN32
#if defined(WIN32) || defined(_WIN32)
#include <windows.h>
#endif


int main()
{
#if defined(WIN32) || defined(_WIN32)
    SetConsoleCP(1250);
    SetConsoleOutputCP(1250);
#endif
    EduList naplo = edulist_inic();
    char* findlabels[] =
    {
        "\tTanr   ",
        "\tTantrgy",
        "\tCsoport ",
        "\traszm "
    };
    char* labels[] =
    {
        "\tTanr neve [maxhossz 30]",
        "\tTantrgy [maxhossz 20]  ",
        "\tCsoport [maxhossz 7]    ",
        "\t-1 | raszm [0;40]     "
    };

    int valasztas, feladat;
    do
    {
        valasztas = feladat = ' ';
        menu_print();
        printf("\n\n\tVlasszon a men sorszmok kzl: ");
        valasztas = getchar();
        while(getc(stdin) != '\n');
        switch(valasztas)
        {
        case '1':
            naplo = file_input(naplo);
            break;
        case '2':
            system("cls");
            printf("\n*****************   FOLYAMATOS KZI ADATBEVITEL   *****************\n");
            printf("\nAdatbevitel megszaktsa: szveg nlkl Enter vagy raszm rtke %d\n\n", STORNO);
            naplo = stdin_input(naplo);
            break;
        case '3':
            printf("\nMgsem: szveg nlkl Enter vagy raszm rtke %d\n",STORNO);
            naplo = edulist_append(naplo, input_edurec(labels));
            break;
        case '4':
            printf("\nBejegyzs trlse pontos egyezs esetn.\n");
            printf("Adja meg a trlend bejegyzs adatait\n");
            edulist_delete(&naplo,input_edurec(findlabels));
            break;
        case '5':
            printf("Minden bejegyzs trlse\n");
            edulist_free(&naplo);
            break;
        case '6':
            printf("\n\t\tAdja meg a lista betjelt: ");
            feladat = getchar();
            while(getc(stdin) != '\n');
            switch(feladat)
            {
            case 'a':
                system("cls");
                printf("\n*****************   TANTRGYFELOSZTS BEJEGYZSEK   *****************\n");
                edulist_print(naplo);
                break;
            case 'b':
                system("cls");
                printf("\n*****************   TANROK NVSORA   *****************\n");
                datafield_print(naplo,teacherlist);
                break;
            case 'c':
                system("cls");
                printf("\n*****************   TANTRGYAK LISTJA   *****************\n");
                datafield_print(naplo,subjectlist);
                break;
            case 'd':
                system("cls");
                printf("\n*****************   OSZTLYOK, CSOPORTOK   *****************\n");
                datafield_print(naplo,grouplist);
                break;
            default:
                break;
            }
            break;
        case '7':
            printf("\n\t\tAdja meg a feladat betjelt: ");
            feladat = getchar();
            while(getc(stdin) != '\n');
            switch(feladat)
            {
            case 'a':
                F2(naplo);
                break;
            case 'b':
                F3(naplo);
                break;
            case 'c':
                F4(naplo);
                break;
            case 'd':
                F5(naplo);
                break;
            case 'e':
                F6(naplo);
                break;
            case 'f':
                F7(naplo);
                break;
            case 'g':
            default:
                system("cls");
                printf("\n*****************   STATISZTIKA   *****************\n");
                F2(naplo);
                F3(naplo);
                F4(naplo);
                F5(naplo);
                F6(naplo);
                F7(naplo);
                break;
            }
            break;
        default:
            break;
        }
        if(valasztas != '8')
        {
            printf("\nj menpont vlasztshoz ssn Entert!");
            while(getc(stdin) != '\n');
        }
    }
    while(valasztas != '8');

    if(naplo.length != 0)
        edulist_free(&naplo);

    return 0;
}
