#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include "statistics.h"
#include "stringset.h"
#include "datamanager.h"


void F2(EduList e)
{
	printf("2. feladat\n");
	printf("\tA fjlban %d bejegyzs van.\n", e.length);
}


void F3(EduList e)
{
	printf("3. feladat\n");
	int sum = 0;
	if(e.length != 0)
		for(EduNode* act = e.first; act != e.last->next; act = act->next)
			sum+= act->adat.ora;

	printf("\tAz iskolban a heti sszraszm: %u\n", sum);
}


void F4(EduList e)
{
	printf("4. feladat\n");
	if(e.length == 0) {
		printf("res a tantrgyfeloszts\n");
		return;
	}

	char nev[TMAX + 1];
	/*ellenrztt adatbekrs*/
	StringSet Teachers = stringset_inic(TMAX);
	for(EduNode* act=e.first; act != e.last->next; act = act->next)
		stringset_insert(&Teachers, act->adat.teacher);
	bool hiba = stringset_isitem(Teachers, nev, TMAX, "\tTanr neve", "Nincs ilyen nev tanr. Adja meg jra.");
	stringset_free(&Teachers);
	if(hiba) {
		printf("\t\tTl sok hibs prba. Nzze meg a tanrok nvsort.\n");
		return;
	}

	int sum = 0;
	for(EduNode* act=e.first; act != e.last->next; act = act->next)
		if(strcmp(act->adat.teacher, nev) == 0)
			sum+= act->adat.ora;
	printf("\t\tA tanr heti raszma: %u\n", sum);
}


void F5(EduList e)
{
	printf("5. feladat\n");
	if(e.length == 0) {
		printf("res a tantrgyfeloszts\n");
		return;
	}
	StringSet Ofok = stringset_inic(GMAX+3+TMAX); /*csoport - tanar*/
	for(EduNode* act=e.first; act != e.last->next; act = act->next)
		if(strcmp(act->adat.subject, "osztalyfonoki") == 0) {
			char rekord[GMAX+3+TMAX];
			/*ha els karakter szm s msodik karakter nem szm, akkor 1 szkzzel kezd*/
			if((act->adat.group[0] >= '0' && act->adat.group[0] <= '9') &&
			        (act->adat.group[1] < '0' || act->adat.group[1] > '9') ) {
				strcpy(rekord, " ");
				strcat(rekord, act->adat.group);
			} else {
				strcpy(rekord, act->adat.group);
			}
			strcat(rekord, " - ");
			strcat(rekord, act->adat.teacher);
			stringset_insert(&Ofok, rekord);
		}

	FILE* ofp;
	ofp = fopen("of.txt", "w");

	stringset_fprint(ofp, Ofok);
	stringset_fprint(stdout, Ofok);
	fclose(ofp);
	stringset_free(&Ofok);
}


void F6(EduList e)
{
	printf("6. feladat\n");
	if(e.length == 0) {
		printf("res a tantrgyfeloszts\n");
		return;
	}

	char group[GMAX+1];
	char subject[SMAX+1];
	/*ellenrztt adatbekrs*/
	bool hiba;
	StringSet Groups = grouplist(e);
	hiba = stringset_isitem(Groups, group, GMAX, "\tOsztly", "Nincs ilyen jel osztly. Adja meg jra.");
	stringset_free(&Groups);
	if(hiba) {
		printf("\t\tTl sok hibs prba. Nzze meg a csoportok listjt.\n");
		return;
	}

	StringSet Subjects = subjectlist(e);
	hiba = stringset_isitem(Subjects, subject, SMAX, "\tTantrgy", "Nincs ilyen nev tantrgy. Adja meg jra.");
	stringset_free(&Subjects);
	if(hiba) {
		printf("\t\tTl sok hibs prba. Nzze meg a tantrgyak listjt.\n");
		return;
	}

	int db = 0;
	for(EduNode* act=e.first; act != e.last->next && db < 2; act = act->next)
		if(strcmp(act->adat.group, group) == 0 && strcmp(act->adat.subject, subject) == 0)
			db++;
	if(db == 0)
		printf("\t\tnem tanuljk.\n");
	else if( db == 1)
		printf("\t\tosztlyszinten tanuljk.\n");
	else
		printf("\t\tcsoportbontsban tanuljk.\n");
}


void F7(EduList e)
{
	printf("7. feladat\n");
	if(e.length == 0) {
		printf("res a tantrgyfeloszts\n");
		return;
	}
	StringSet Teachers = teacherlist(e);
	printf("\tAz iskolban %u tanr tant\n", stringset_length(Teachers));
	stringset_free(&Teachers);
}
