#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "stringset.h"
#include "edurec.h"
#include "datamanager.h"

/*Nem hasznlt fgv: egy node trlse*/
//#define extrafunc

StringItem* createstring(char* s, unsigned maxlength)
{
	if(s == NULL || strlen(s) > maxlength)
		return NULL;
	StringItem* uj = (StringItem*)malloc(sizeof(StringItem));
	uj->length=maxlength;
	uj->str = (char*)malloc(sizeof(char)*(maxlength + 1));
	strncpy(uj->str, s, maxlength + 1);
	return uj;
}


void deletestring(StringItem* strit)
{
	if(strit->str != NULL)
		free(strit->str);
	free(strit);
	strit = NULL;
}


StringNode* stringnode_insertstr(StringNode* sn, char* s, unsigned maxlength)
{
	StringNode* uj = (StringNode*)malloc(sizeof(StringNode));
	uj->strlength = maxlength;
	uj->strit = createstring(s, uj->strlength);
	uj->right = NULL;
	uj->left = NULL;

	if(sn == NULL) { /*res fa*/
		uj->root = NULL;

		return uj;
	}
	StringNode* ez = sn;
	while(ez != uj && strcmp(ez->strit->str, s)!= 0) {

		if(strcmp(ez->strit->str, s) > 0) {
			if(ez->left == NULL) {  /*balra betesz*/
				uj->root = ez;
				ez->left = uj;
				ez = uj;
			} else {                /*balra lp*/
				ez = ez->left;
			}
		} else if(strcmp(ez->strit->str, s) < 0) {
			if(ez->right == NULL) { /*jobbra betesz*/
				uj->root = ez;
				ez->right = uj;
				ez = uj;
			} else {                /*jobbra lp*/
				ez = ez->right;
			}
		}
	}
	if(ez != uj) {
		deletestring(uj->strit);
		free (uj);
		uj = NULL;
	}
	return sn;
}


StringNode* stringnode_find(StringNode* sn, char* s)
{
	if(sn == NULL) { /*res fa*/
		return sn;
	}
	StringNode* ez = sn;
	while(strcmp(ez->strit->str, s)!= 0) {

		if(strcmp(ez->strit->str, s) > 0) {
			if(ez->left == NULL) {  /*balra kellene lennie, de nincs*/
				return NULL;
			} else {                /*balra lp*/
				ez = ez->left;
			}
		}
		if(strcmp(ez->strit->str, s) < 0) {
			if(ez->right == NULL) { /*jobbra kellene lennie, de nincs*/
				return NULL;
			} else {                /*jobbra lp*/
				ez = ez->right;
			}
		}
	}
	return ez;
}


StringNode* stringnode_dropstr(StringNode* sn, char* s)
{
#ifdef extrafunc
	StringNode* ezt = stringnode_find(sn, s);
	if(ezt != NULL) {
		if(ezt->left == NULL && ezt->right == NULL) {               /*levl*/
			if(ezt->root != NULL && ezt->root->left == ezt) {       /*bal levl*/
				ezt->root->left = NULL;
			} else if(ezt->root != NULL && ezt->root->right == ezt) { /*jobb levl*/
				ezt->root->right = NULL;
			} else {    /*ezt->root == NULL*/
				sn = NULL;                          /*gykr, egyetlen csomopont*/
			}
		} else if(ezt->right == NULL) { /*nem levl -> balra van gyerek*/
			if(ezt->root == NULL) {     /*gykr bal gyerekkel*/
				sn = ezt->left;
			} else {                    /*bal gyerek tktse a szlhz*/
				ezt->left->root = ezt->root;
				if (ezt->root->left == ezt) /*balra*/
					ezt->root->left = ezt->left;
				else                        /*jobbra*/
					ezt->root->right = ezt->left;
			}
		} else if(ezt->left == NULL) {  /*nem levl -> jobbra van gyerek*/
			if(ezt->root == NULL) {     /*gykr jobb gyerekkel*/
				sn = ezt->right;
			} else {                    /*jobb gyerek ktse a szlhz*/
				ezt->right->root = ezt->root;
				if (ezt->root->left == ezt) /*balra*/
					ezt->root->left = ezt->right;
				else                        /*jobbra*/
					ezt->root->right = ezt->right;
			}

		} else {                        /*kt gyerek van*/
			if(ezt->root == NULL)       /*gykr = bal gyerek*/
				sn = ezt->left;
			else {                      /*belso node -> bal gyerek szlhz ktse*/
				ezt->root = ezt->left;
				ezt->left->root = ezt->root;
			}
			StringNode* jobbag = ezt->right; /*jobb gyerek beszrsa j helyre*/
			jobbag->root = NULL;
			StringNode* ide = sn;
			while(strcmp(ide->strit->str, jobbag->strit->str)!= 0) {

				if(strcmp(ide->strit->str, jobbag->strit->str) < 0) {
					if(ide->left == NULL) {  /*balra betesz*/
						jobbag->root = ide;
						ide->left = jobbag;
					} else {                /*balra lp*/
						ide = ide->left;
					}
				}
				if(strcmp(ide->strit->str, jobbag->strit->str) > 0) {
					if(ide->right == NULL) { /*jobbra betesz*/
						jobbag->root = ide;
						ide->right = jobbag;
					} else {                /*jobbra lp*/
						ide = ide->right;
					}
				}
			}
		}
		deletestring(ezt->strit);
		free(ezt);
		ezt = NULL;
	}
#endif // extrafunc
	return sn;
}


void stringnode_fprint(FILE* f, StringNode* sn)
{
	if(sn->left != NULL)
		stringnode_fprint(f, sn->left);
	fprintf(f, "%s\n", sn->strit->str);
	if(sn->right != NULL)
		stringnode_fprint(f, sn->right);
}


void stringnode_free(StringNode* sn)
{
	if(sn->left != NULL)
		stringnode_free(sn->left);
	if(sn->right != NULL)
		stringnode_free(sn->right);

	if(sn->root != NULL && sn->root->left == sn)
		sn->root->left = NULL;
	else if(sn->root != NULL && sn->root->right == sn)
		sn->root->right = NULL;

	deletestring(sn->strit);
	free(sn);
	sn = NULL;
}


unsigned stringnode_length(StringNode* sn)
{
	unsigned num = 1;
	if(sn->left != NULL)
		num += stringnode_length(sn->left);
	if(sn->right != NULL)
		num +=stringnode_length(sn->right);
	return num;
}


StringSet stringset_inic(unsigned strlength)
{
	StringSet uj;
	uj.strlength = strlength;
	uj.first = NULL;
	return uj;
}


void stringset_insert(StringSet* ss, char* s)
{
	if(strlen(s) > ss->strlength)
		printf("a berand adat tl hossz");
	else if(strlen(s)== 0)
		printf("0 hosszsg string nem trolhat");
	else if(stringnode_find(ss->first, s) == NULL) {
		ss->first = stringnode_insertstr(ss->first, s, ss->strlength);
	}
}

StringNode* stringset_find(StringSet ss, char* s)
{
	return stringnode_find(ss.first, s);
}


void stringset_delete(StringSet* ss, char* s)
{
#ifdef extrafunc
	ss->first = stringnode_dropstr(ss->first, s);
#endif // extrafunc
}

void stringset_fprint(FILE* f, StringSet ss)
{
	if(ss.first != NULL)
		stringnode_fprint(f, ss.first);
}


void stringset_free(StringSet* ss)
{
	if(ss != NULL && ss->first != NULL) {
		StringNode* it = ss->first;
		stringnode_free(it);
	}
}


unsigned stringset_length(StringSet ss)
{
	if(ss.first == NULL)
		return 0;
	return stringnode_length(ss.first);
}


bool stringset_isitem(StringSet ss, char* s, unsigned maxlength, const char* question, const char* message)
{
	bool hiba;
	int proba = 0;
	do {
		hiba = false;
		input_stringfield(question, s, maxlength);
		StringNode* sn = stringset_find(ss, s);
		hiba = (sn == NULL);
		if(hiba) {
			proba++;
			if(proba < 3)
				printf("\t\t%s\n", message);
		}
	} while(hiba && proba < 3);
	return hiba;
}
