/*Adott maxmret szvegeket tartalmaz ismtldsmentes binris fa*/
#ifndef STRINGSET_H
#define STRINGSET_H

#include <stdbool.h>

typedef struct stringitem
{
    char* str;
    unsigned length;
}StringItem;

typedef struct stringnode{
    StringItem* strit;
    unsigned strlength;
    struct stringnode* root;
    struct stringnode* right;
    struct stringnode* left;
}StringNode;

typedef struct stringset{
    StringNode* first;
    unsigned strlength; //szoveg maxhossz
}StringSet;

StringItem* createstring(char* s, unsigned maxlength);
void deletestring(StringItem* strit);

StringNode* stringnode_insertstr(StringNode* sn, char* s, unsigned maxlength);
StringNode* stringnode_find(StringNode* sn, char* s);
StringNode* stringnode_dropstr(StringNode* sn, char* s); //extrafunc
void stringnode_fprint(FILE* f, StringNode* sn);
void stringnode_free(StringNode* sn);
unsigned stringnode_length(StringNode* sn);

StringSet stringset_inic(unsigned strlength);
void stringset_insert(StringSet* ss, char* s);
StringNode* stringset_find(StringSet ss, char* s);
void stringset_delete(StringSet* ss, char* s); //extrafunc
void stringset_fprint(FILE* f, StringSet ss);
void stringset_free(StringSet* ss);
unsigned stringset_length(StringSet ss);
bool stringset_isitem(StringSet ss, char* s, unsigned maxlength, const char* question, const char* message);

#endif // STRINGSET_H
